package de.unibi.airobots.bonsai.util.arm.calibration;

import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathExpression;
import javax.xml.xpath.XPathFactory;

import org.w3c.dom.Document;
import org.w3c.dom.NodeList;

import Jama.Matrix;
import Jama.SingularValueDecomposition;

/*
 * HomographyCalculation.java
 * 
 *  Created on: Jan 31, 2011
 *      Author: lziegler, abaumann, mdulisch
 *      
 */

public class HomographyCalculation {

	private static final String DEFAULT_MATRIX_FILE = "transformationMatrixOutput";

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		System.out.println("bla");
		HomographyCalculation hc = new HomographyCalculation();
		hc.readXMLFile2();
		int i = 0;
		while( i < 2) {
			
		}
		System.exit(0);
		hc.readXMLFile("testdata.xml");
		System.exit(0);
		Matrix[] a = new Matrix[4];
		Matrix[] b = new Matrix[4];
		double[][] vecA = {{19.487388388849894*0.6},
							{4.817466579062504*0.6},
							{3.759393862554037*0.6}};
		double[][] vecB = {{0.06413162231445313},
				{0.02404936218261719},
				{0.577}};
		a[0] = new Matrix(vecA);
		b[0] = new Matrix(vecB);
		
		double[][] vecA1 ={{12.536297254306803*0.6},
				{11.792805703029178*0.6},
				{12.917156297940682*0.6}};
		double[][] vecB1 = {{0.06402047729492187},
				{-0.0240076789855957},
				{0.5760000610351562}};
		a[1] = new Matrix(vecA1);
		b[1] = new Matrix(vecB1);

		double[][] vecA2 ={{18.95032085174429*0.6},
				{12.414032157227236*0.6},
				{19.621778411157347*0.6}};
		double[][] vecB2 = {{0.06402047729492187},
				{-0.0240076789855957},
				{0.5760000610351562}};
		a[2] = new Matrix(vecA2);
		b[2] = new Matrix(vecB2);

		double[][] vecA3 ={{16.40449069178977*0.6},
				{3.347687351930253*0.6},
				{12.0768165097642*0.6}};
		double[][] vecB3 = {{0.06413162231445313},
				{-0.02404936218261719},
				{0.577}};
		a[3] = new Matrix(vecA3);
		b[3] = new Matrix(vecB3);

		
		hc.calculate(a, b);
	}
	
	public void readXMLFile2() {
		System.out.println("loarl");
		try{
			String[] file = new String[8];
			file[0] = "pos0";
			file[1] = "pos1";
			file[2] = "pos2";
			file[3] = "pos3";
			file[4] = "pos4";
			file[5] = "pos5";
			file[6] = "pos6";
			file[7] = "pos7";
			DocumentBuilderFactory domFactory = DocumentBuilderFactory.newInstance();
		    domFactory.setNamespaceAware(true);
		    DocumentBuilder builder = domFactory.newDocumentBuilder();
		    int i = 0;
		    String op = "<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"no\" ?>\n<CALIBRATION>\n\t<POSES>\n";
		    System.out.println(op);
			for(String filename: file) {
				System.out.println(filename);
			    Document doc = builder.parse("/home/biron/" + filename);
		
				
				XPathFactory factory = XPathFactory.newInstance();
			    XPath xpath = factory.newXPath();
			    XPathExpression expr 
			     = xpath.compile("/POSITION");
		
			    Object result = expr.evaluate(doc, XPathConstants.NODESET);
			    NodeList nodes = (NodeList) result;
			    //System.out.println("//" + filename);
			    //System.out.println("poses[" + i++ + "] = new PoseData(" + nodes.item(0).getAttributes().item(0).getNodeValue() + ", " + nodes.item(0).getAttributes().item(1).getNodeValue() + ", " + nodes.item(0).getAttributes().item(2).getNodeValue() + ");");
			    op += "\t\t<POSE " + 
			    		   "x=\"" + nodes.item(0).getChildNodes().item(2).getAttributes().item(0).getNodeValue() + 
			    		"\" y=\"" + nodes.item(0).getChildNodes().item(2).getAttributes().item(1).getNodeValue() + 
			    		"\" z=\"" + nodes.item(0).getChildNodes().item(2).getAttributes().item(2).getNodeValue() + 
			    		"\" phi=\"" + nodes.item(0).getChildNodes().item(3).getAttributes().item(0).getNodeValue() + 
			    		"\" psi=\"" + nodes.item(0).getChildNodes().item(3).getAttributes().item(1).getNodeValue() + 
			    		"\" theta=\"" + nodes.item(0).getChildNodes().item(3).getAttributes().item(2).getNodeValue() + 
			    		"\" />\n";
			    
			}
			op += "\t</POSES>\n</CALIBRATION>";
			FileOutputStream fs = new FileOutputStream("/vol/robocup/trunk/etc/armcalibration/calibrationposes.xml");
			fs.write(op.getBytes());
			fs.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public void readXMLFile(String filename) {
		try {
			DocumentBuilderFactory domFactory = DocumentBuilderFactory.newInstance();
		    domFactory.setNamespaceAware(true);
		    DocumentBuilder builder = domFactory.newDocumentBuilder();
		    Document doc = builder.parse(filename);
	
			
			XPathFactory factory = XPathFactory.newInstance();
		    XPath xpath = factory.newXPath();
		    XPathExpression expr 
		     = xpath.compile("/vectors/pair");
	
		    Object result = expr.evaluate(doc, XPathConstants.NODESET);
		    NodeList nodes = (NodeList) result;
		    Matrix[] a = new Matrix[nodes.getLength()];
		    Matrix[] b = new Matrix[nodes.getLength()];
		    System.out.println("using points:");
		    for (int i = 0; i < nodes.getLength(); i++) {
		        for(int j = 0; j < nodes.item(i).getChildNodes().getLength(); j++) {
				    double[][] vecA = new double[3][1];
				    double[][] vecB = new double[3][1];
		        	try {
		        		if (nodes.item(i).getChildNodes().item(j).getNodeName().equals("target")) {
		        			vecB[0][0] = Double.valueOf(nodes.item(i).getChildNodes().item(j).getAttributes().item(0).getNodeValue());
		        			vecB[1][0] = Double.valueOf(nodes.item(i).getChildNodes().item(j).getAttributes().item(1).getNodeValue());
		        			vecB[2][0] = Double.valueOf(nodes.item(i).getChildNodes().item(j).getAttributes().item(2).getNodeValue());
		        			b[i] = new Matrix(vecB);
		        			System.out.println("target:");
		        			b[i].print(3, 1);
		        			System.out.println("---------");
		        		} else if (nodes.item(i).getChildNodes().item(j).getNodeName().equals("original")) {
		        			vecA[0][0] = Double.valueOf(nodes.item(i).getChildNodes().item(j).getAttributes().item(0).getNodeValue())*0.6;
		        			vecA[1][0] = Double.valueOf(nodes.item(i).getChildNodes().item(j).getAttributes().item(1).getNodeValue())*0.6;
		        			vecA[2][0] = Double.valueOf(nodes.item(i).getChildNodes().item(j).getAttributes().item(2).getNodeValue())*0.6;
		        			a[i] = new Matrix(vecA);
		        			System.out.println("original:");
		        			a[i].print(3, 1);
		        		}
		        	} catch (NullPointerException e) {
		        		
		        	}
		        }
		    }
	        for(Matrix ai: a) {
	        	ai.print(3, 1);
	        }
		    this.calculate(a, b);
		} catch (Exception e) {
			e.printStackTrace();
		}

	}
	
	/**
	 * Calculate mean vectors of two sets of column vectors.
	 * @param pointsA First set of column vectors.
	 * @param pointsB Second set of column vectors.
	 * @return Set of mean vectors.
	 * Index 0 -> Mean vector of first set of column vectors
	 * Index 1 -> Mean vector of second set of column vectors
	 * 
	 */
	public Matrix[] calculateMeanVectors(Matrix[] pointsA, Matrix[] pointsB) {
		// calculate mean vectors
		double[] v0 = new double[3];
		double[] v1 = new double[3];
		for (int i = 0; i < pointsA.length; i++) {
			v0[0] += pointsA[i].get(0, 0);
			v0[1] += pointsA[i].get (1, 0);
			v0[2] += pointsA[i].get (2, 0);
			v1[0] += pointsB[i].get (0, 0);
			v1[1] += pointsB[i].get (1, 0);
			v1[2] += pointsB[i].get (2, 0);
		}
		v0[0] /= (float) pointsA.length;
		v0[1] /= (float) pointsA.length;
		v0[2] /= (float) pointsA.length;
		v1[0] /= (float) pointsB.length;
		v1[1] /= (float) pointsB.length;
		v1[2] /= (float) pointsB.length;

		Matrix[] matrices = new Matrix[2];
		matrices[0] = new Matrix(v0, 3);
		matrices[1] = new Matrix(v1, 3);

		System.out.println("mean a: " + v0[0] + " " + v0[1] + " " + v0[2]);
		System.out.println("mean b: " + v1[0] + " " + v1[1] + " " + v1[2]);
		System.out.println("diff: " + (v0[0]-v1[0]) + " " + (v0[1]-v1[1]) + " " + (v0[2]-v1[2]));
		
		return matrices;
	}

	/**
	 * Calculate a covariance matrix of given vectors.
	 * Resource saving version, if mean vectors are known.
	 * @param pointsA First array of column vectors to compute the covariance matrix of.
	 * @param pointsB Second array of column vectors to compute the covariance matrix of.
	 * @param am Mean vector of first set of vectors.
	 * @param bm Mean vector of second set of vectors.
	 */
	public Matrix calculateCovarianceMatrix (Matrix[] pointsA, Matrix[] pointsB, Matrix am, Matrix bm) {
		// calculate covariance matrix
		Matrix K = new Matrix(am.getRowDimension(), am.getRowDimension());

		System.out.print("calculating covariance... ");
		for (int i = 0; i < pointsA.length; i++) {
			Matrix ai = pointsA[i];
			Matrix bj = pointsB[i];

			K = K.plus(bj.minus(bm).times((ai.minus(am)).transpose()));
		}
		System.out.println("done");
		return K;
	}
	
	/**
	 * Calculate a covariance matrix of given vectors.
	 * !Use with caution!
	 * If mean vectors are known, use resource saving version!
	 * @param pointsA First array of column vectors to compute the covariance matrix of.
	 * @param pointsB Second array of column vectors to compute the covariance matrix of.
	 */
	public Matrix calculateCovarianceMatrix (Matrix[] pointsA, Matrix[] pointsB) {
		Matrix[] meanVectors = calculateMeanVectors(pointsA, pointsB);
		return calculateCovarianceMatrix(pointsA, pointsB, meanVectors[0], meanVectors[1]);
	}
	
	/**
	 * Calculated the rotation matrix.
	 * @param svd Singular Value Decomposition of a matrix.
	 * @return The calculated rotation matrix.
	 */
	public Matrix calculateRotationMatrix(SingularValueDecomposition svd) {
		// calculate rotation matrix
		System.out.print("calculating rotation... ");
		Matrix R = svd.getU().times(svd.getV().transpose());  //.tranpose()?
		System.out.println("done");
		double determinant = R.det();
		if (!(determinant < 1.001 && determinant > 0.9999)) {
			System.err.println("ERROR: determinant not 1");
			System.exit(1);
		}
		return R;
	}
	
	/**
	 * Calculates the transformation matrix.
	 * @param R Rotation matrix to use.
	 * @param am Mean vector of first set of column vectors.
	 * @param bm Mean vector of second set of column vectors.
	 * @return The transformation matrix.
	 */
	public Matrix calculateTransformationMatrix(Matrix R, Matrix am, Matrix bm) {
		// calculate transformation matrix
		System.out.print("calculating transformation... ");
		Matrix t = bm.minus(R.times(am));
		System.out.println("done");
		return t;
	}
	
	/**
	 * Puts together the rotation and transformation matrix to one single matrix.
	 * @param R
	 * @param T
	 * @return The composed matrix.
	 */
	public Matrix putBothTogether(Matrix R, Matrix T) {
		// put both together
		System.out.print("calculating joined transformation... ");
		Matrix joinedTransformation = new Matrix(4,4);
		joinedTransformation.set(3, 3, 1.0);
		// rotation
		joinedTransformation.setMatrix(0, 2, 0, 2, R);
		// translation
		joinedTransformation.setMatrix(0, 2, 3, 3, T);
		System.out.println("done");
		return joinedTransformation;
	}
	
	/**
	 * To test a calculated transformation matrix.
	 * @param pointsA First set of column vectors.
	 * @param pointsB Second set of column vectors.
	 * @param am Mean vector of first set of column vectors.
	 * @param bm Mean vector of second set of column vectors.
	 * @param joinedTransformation composition of rotation and transformation matrix.
	 * @param T Transformation matrix.
	 * @param R Rotation matrix.
	 */
	public void test(Matrix[] pointsA, Matrix[] pointsB, Matrix am, Matrix bm, Matrix joinedTransformation, Matrix T, Matrix R) {
		// test
		double normSum0 = 0;
		for (int i = 0; i < pointsA.length; i++) {
			Matrix testMat = new Matrix(4, 1);
			testMat.setMatrix(0, 2, 0, 0, pointsA[i]);
			testMat.set(3, 0, 1.0);
			Matrix truthMat = new Matrix(4, 1);
			truthMat.setMatrix(0, 2, 0, 0, pointsB[i]);
			truthMat.set(3, 0, 1.0);
			Matrix outMat0 = joinedTransformation.times(testMat);
			Matrix diffMat0 = outMat0.minus(truthMat);

			double norm0 = diffMat0.norm2() * diffMat0.norm2();
			normSum0 += norm0;

			System.out.println("\nTest: ");
			System.out.print(testMat.get(0, 0) + " ");
			System.out.print(testMat.get(1, 0) + " ");
			System.out.print(testMat.get(2, 0) + " ");
			System.out.print(testMat.get(3, 0) + " ");
			System.out.print(" -> ");
			System.out.print(outMat0.get(0, 0) + " ");
			System.out.print(outMat0.get(1, 0) + " ");
			System.out.print(outMat0.get(2, 0) + " ");
			System.out.print(outMat0.get(3, 0) + " ");
			System.out.print(" ( ");
			System.out.print(diffMat0.get(0, 0) + " ");
			System.out.print(diffMat0.get(1, 0) + " ");
			System.out.print(diffMat0.get(2, 0) + " ");
			System.out.print(diffMat0.get(3, 0) + " ");
			System.out.println(" ) error: " + norm0);
		}
		normSum0 /= (double) pointsA.length;

		System.out.println();
		System.out.println("mean square error 0: " + normSum0);

		Matrix outMean = (R.times(am)).plus(T);
		Matrix diffMean = outMean.minus(bm);

		System.out.println("out mean: " + outMean.get(0, 0) + " "
				+ outMean.get(1, 0) + " " + outMean.get(2, 0));
		System.out.println("diff mean: " + diffMean.get(0, 0) + " " + diffMean.get(1, 0)
				+ " " + diffMean.get(2, 0));
	}
	
	/**
	 * The main calculation.
	 * Calculates a transformation matrix of two sets of column vectors.
	 * @param pointsA First set of column vectors.
	 * @param pointsB Second set of column vectors.
	 * @return The transformation matrix.
	 */
	public void calculate(Matrix[] pointsA, Matrix[] pointsB) {
		Matrix[] meanVectors = this.calculateMeanVectors(pointsA, pointsB);
		Matrix am = meanVectors[0];
		Matrix bm = meanVectors[1];
		Matrix K = this.calculateCovarianceMatrix(pointsA, pointsB, am, bm);
		SingularValueDecomposition svd = K.svd();
		Matrix R = this.calculateRotationMatrix(svd);
		Matrix T = calculateTransformationMatrix(R, am, bm);
		Matrix J = putBothTogether(R, T);
		this.test(pointsA, pointsB, am, bm, J, T, R);
		J.print(4, 4);
		this.exportPlainText(J);
	}

	private void exportPlainText(Matrix j) {
		this.exportPlainText(j, DEFAULT_MATRIX_FILE);
	}
	
	private void exportPlainText(Matrix m, String filename) {
		try {
			FileOutputStream fo = new FileOutputStream(filename);
		    String output = "";
		    for(int i = 0; i < m.getRowDimension(); i++) {
		    	for(int j = 0; j < m.getColumnDimension(); j++) {
			    	output += m.get(i, j);
			    	if (j!=m.getColumnDimension()-1) output += " ";
			    }
		    	output += "\n";
		    }
			fo.write(output.getBytes());
			fo.flush();
			fo.close();
		} catch (FileNotFoundException e) {
			System.err.println(filename + ": No such directory.");
		} catch (IOException e) {
			System.err.println("Could not write to file " + filename);
		}
	}
}
